package com.lotadata.geo_sdk_flutter_plugin

import android.app.Activity
import android.content.pm.ApplicationInfo
import android.content.pm.PackageManager.GET_META_DATA
import com.lotadata.moments.events.LDEvent
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar



class GeoSdkFlutterPlugin: MethodCallHandler {


  var activity: Activity? = null
  var geoSdkChannel: MethodChannel? = null

  private var mGeoSDK: GeoSDK? = null


  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "geo_sdk_flutter_plugin")
      channel.setMethodCallHandler(GeoSdkFlutterPlugin(registrar.activity(), channel))
    }
  }


  constructor(activity: Activity, channel: MethodChannel) {
    this.activity = activity
    this.geoSdkChannel = channel
    this.mGeoSDK = GeoSDK(activity, channel)
  }


  private fun geoSdkInstance(): GeoSDK {

    return GeoSDK(this.activity, this.geoSdkChannel)

  }



  override fun onMethodCall(call: MethodCall, result: Result) {
    if (this.mGeoSDK == null) this.mGeoSDK = geoSdkInstance()

    if (call.method == "checkPermissionsAndLaunch") {
      mGeoSDK!!.checkPermissionsAndLaunch()
      result.success(true)
    } else if (call.method == "getLastEvent") {

      var ldEvent = mGeoSDK!!.lastEvent

      result.success(ldEvent)

    } else if (call.method == "disposeSdk"){
      mGeoSDK!!.disposeSdk()
      result.success(true)
    } else if (call.method == "getSDKVersion") {
      var version: String = mGeoSDK!!.sdkVersion
      result.success(version)
    } else {
      result.notImplemented()
    }

  }
  
  



}
